Module DatenHandling

    Public Function ConvertDataField(ByVal pData As String, ByVal pTyp As Integer) As String
        Dim szReturn As String
        '       Dim szTemp As String
        Dim byteArray() As Byte
        Dim szDateTime As String
        Dim szYearHundred As String
        Dim szYear As String
        Dim szMonth As String
        Dim szDay As String
        Dim szHouer As String
        Dim szMinute As String
        Dim szSecond As String

        szReturn = ""

        ''        Dim test As Integer
        ''        Dim temp As String

        Select Case (pTyp)
            Case 1
                ' unsigned long 4 Byte (Timeboy Datentyp)
            Case 2
                ' Date/Time 7 Byte
                byteArray = System.Text.ASCIIEncoding.ASCII.GetBytes(pData)

                szYearHundred = byteArray(0).ToString("00")
                szYear = byteArray(1).ToString("00")
                szMonth = byteArray(2).ToString("00")
                szDay = byteArray(3).ToString("00")
                szHouer = byteArray(4).ToString("00")
                szMinute = byteArray(5).ToString("00")
                szSecond = byteArray(6).ToString("00")

                szDateTime = szDay & "." & szMonth & "." & szYearHundred & szYear & _
                             " " & _
                             szHouer & ":" & szMinute & ":" & szSecond

                szReturn = szDateTime.ToString
            Case 3
                ' ASCII 0x30 - 0x39
                ' test = pData.Length()
                ' temp = pData.ToString.Replace(Chr(0), Nothing)

                szReturn = pData.Substring(0, pData.Length())
            Case 4
                ' ASCII Alpha-Numerisch
                ' test = pData.Length()
                '  temp = pData.ToString.Replace(Chr(0), Nothing)

                szReturn = pData.Substring(0, pData.Length())
            Case 5
                ' Date 4 Byte (y100,y,m,d) (Timeboy Datentyp)
            Case 6
                ' Time 3 Byte (h,m,s) (Timeboy Datentyp)
            Case 7
                ' Template Daten (DIN Format 161 Byte)
            Case 8
                ' Template Daten (Idencom Format 216 Byte)
            Case Else
                ' Der Feldtyp ist unbekannt, Returnvalue wird auf "" gesetzt
                szReturn = "undefined"
        End Select

        Return szReturn.ToString
    End Function

    Public Function GetData(ByVal pRecord As String, ByVal DSB() As STRecordDefinition, ByVal pDateTime As Integer) As String
        ' Etwas hilfreiches bereitstellen
        Dim iDSNum As Integer = -1
        Dim szChar As Char
        ' Dim iFInum As Integer = -1
        Dim iFIlength As Integer = 0
        Dim iFItype As Integer = -1
        Dim szFIvalue As String = ""
        Dim szDatensatz As String = ""
        Dim szReturn As New System.Text.StringBuilder(szDatensatz)
        ' Wir beginnen nicht bei Index 0, denn das ist ja die Nummer der Datensatzbeschreibung
        Dim iStartPos As Integer = 1
        Dim iEndPos As Integer = -1
        ' Kennung fr die Datensatzbeschreibung ermitteln
        szChar = pRecord.Substring(0, 1)
        ' Nummer der Datensatzbeschreibung festlegen
        If (pDateTime = 0) Then

            Select Case (szChar)
                Case Chr(0)
                    iDSNum = 0
                Case Chr(1)
                    iDSNum = 1
                Case Chr(2)
                    iDSNum = 2
                Case Chr(3)
                    iDSNum = 3
                Case Chr(4)
                    iDSNum = 4
                Case Chr(5)
                    iDSNum = 5
                Case Chr(6)
                    iDSNum = 6
                    ' Hier sind max. 20 Datensatzbeschreibungen mglich
            End Select

            ' Wir zerlegen den Datensatz entsprechend der Anzahl Felder aus der Datensatzbeschreibung
            '  szDatensatz = ""
            Dim len As Integer
            len = pRecord.Length()
            Dim ch(len) As Char
            szDatensatz = New String(ch)
            ''For x As Integer = 0 To len - 1
            ''    ch(x) = pRecord(x)
            ''Next
            If (len > 1) Then
                iStartPos = 1
                For i As Integer = 0 To STR(iDSNum).ReFieldCount - 1
                    iEndPos = STR(iDSNum).ReFields(i).FiLength
                    szFIvalue = pRecord.Substring(iStartPos, iEndPos)
                    '     szDatensatz = ConvertDataField(szFIvalue, DSB(iDSNum).DSFields(i).FItyp)
                    szReturn.Append(ConvertDataField(szFIvalue, STR(iDSNum).ReFields(i).FiTyp))
                    szReturn.Append(vbTab)
                    iStartPos = iStartPos + iEndPos
                    'szDatensatz = szReturn.ToString
                Next
                szReturn.Append(vbCrLf)
                ' szReturn.ToString.Trim(Chr(0))
            Else
                szReturn.Append("undefiniert")
            End If
        Else
            ''            szReturn.Append(ConvertDataField(pRecord, 2))
        End If

        ' Hier noch aufrumen, bevor wir die Sache weitergeben
        Dim szOutput As String
        szOutput = szReturn.ToString.Replace(Chr(0), " ")
        ' Hier sollten uns die lesbaren Daten vorliegen
        Return szOutput.ToString
    End Function

End Module
