/**
 * @file  DFFileDeviceText.h
 * @brief Schnittstelle fuer die Klasse CDFFileDeviceText.
 */
//////////////////////////////////////////////////////////////////////
#ifndef _DFFILEDEVICETEXT_H_
#define _DFFILEDEVICETEXT_H_

#include "ErrorState.h"

// Basisklasse 
//#include "DFFileIni.h"

class CDFFileDeviceText //: public CDFFileIni
{
public:
	CDFFileDeviceText();
	virtual ~CDFFileDeviceText();

	void Reset();
	inline int GetLastErrorState() { return m_errorState; };
	inline unsigned long GetSizeData() { return m_sizeData; };

	int Load(char *fileName);
	int Save(char *fileName, unsigned char append = 0);

protected:
	int m_errorState;
	unsigned long m_sizeData;
};

#endif

